/*
 * Created on Jan 17, 2005
 *
 */
package com.cachingapp.logging;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.loanapp.servlet.LoanAppServlet;

/**
 * @author Administrator
 *
 */
public aspect CacheLog {
    
    private static Log sLog = LogFactory.getLog(CacheLog.class);
    
    pointcut logInterestRateCalls() :
	  call(* *.getInterestRates(..)) && !within(CacheLog);
	
	before() : logInterestRateCalls() {
	    sLog.debug("getKind " + thisJoinPointStaticPart.getKind());
	    sLog.debug("toLongString " + thisJoinPointStaticPart.toLongString());
	    sLog.debug("toShortString " + thisJoinPointStaticPart.toShortString());
	    sLog.debug("toString " + thisJoinPointStaticPart.toString());
	    sLog.debug("getSignature " + thisJoinPointStaticPart.getSignature());
	    sLog.debug("getSourceLocation " + thisJoinPointStaticPart.getSourceLocation());
	    
	    sLog.debug("Calling " + thisJoinPoint.toShortString());
	}
	
	after() : logInterestRateCalls() {
	  sLog.debug(thisJoinPoint.toShortString() + " called.");
	}
	
	pointcut logServletCalls() :
	    execution(* LoanAppServlet.service(..)) && !within(CacheLog);

	before() : logServletCalls() {
	    sLog.debug("Calling " + thisJoinPoint.toShortString());
	}
		
	after() : logServletCalls() {
	    sLog.debug(thisJoinPoint.toShortString() + " called.");
	}
}
