package com.fsb.aspects.logging;

import org.codehaus.aspectwerkz.joinpoint.JoinPoint;
import org.codehaus.aspectwerkz.joinpoint.MethodRtti;

/**
 * @author
 */
public class SQLTracingAspect {

    /**
     * @Around execution(* java.sql.Connection+.prepare*(..))
     */
    public Object logJdbcQueries(final JoinPoint joinPoint) throws Throwable {
        MethodRtti rtti = (MethodRtti)joinPoint.getRtti();
        String query = (String)rtti.getParameterValues()[0];
        System.out.println("===> query: " + query);
        return joinPoint.proceed();
    }

    /**
     * @Around execution(void java.sql.PreparedStatement+.set*(..))
     */
    public Object logValuesInPreparedStatement(final JoinPoint joinPoint) throws Throwable {
        MethodRtti rtti = (MethodRtti)joinPoint.getRtti();
        Integer index = (Integer)rtti.getParameterValues()[0];
        Object value = rtti.getParameterValues()[1];
        System.out.println("     index=" + index.intValue() + " value=" + value.toString());
        return joinPoint.proceed();
    }
}
