/*
 * Created on Jan 17, 2005
 *
 */
package com.cachingapp.tracing;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * @author Administrator
 *
 */
public aspect SQLTrace {
    
    private static Log sLog = LogFactory.getLog(SQLTrace.class);
    
    pointcut logJdbcQueries() :  
    	 call(* java.sql.Connection+.prepare*(..));
    Object around() : logJdbcQueries()
    {
//        MethodRtti rtti = (MethodRtti)joinPoint.getRtti();
//        String query = (String)rtti.getParameterValues()[0];
//        System.out.println("===> query: " + query);
        
        sLog.debug(thisJoinPoint.toShortString());
        
		String query = (String)thisJoinPoint.getArgs()[0];
		sLog.debug("===> query: " + query);
        
        return proceed();
    }

    pointcut logSQLQueries() :  
   	 call(* java.sql.Connection+.create*(..));
   Object around() : logSQLQueries()
   {
       sLog.debug(thisJoinPoint.toShortString());
       
		String query = (String)thisJoinPoint.getArgs()[0];
		sLog.debug("===> query: " + query);
       
       return proceed();
   }
   
   pointcut logValuesInPreparedStatement() : 
       (execution(void java.sql.PreparedStatement+.set*(..)));
   Object around() : logValuesInPreparedStatement() {
       sLog.debug(thisJoinPoint.toShortString());
           
       Object[] methodArgs = thisJoinPoint.getArgs();
       Integer index = (Integer)methodArgs[0];
       Object value = methodArgs[1];
       sLog.debug("     index=" + index.intValue() + " value=" + value.toString());
       return proceed();
   }

   pointcut logValuesInSQLStatement() : 
       (call(void java.sql.Statement+.set*(..)));
   Object around() : logValuesInSQLStatement() {
           
       sLog.debug(thisJoinPoint.toShortString());
           
       Object[] methodArgs = thisJoinPoint.getArgs();
       Integer index = (Integer)methodArgs[0];
       Object value = methodArgs[1];
       sLog.debug("     index=" + index.intValue() + " value=" + value.toString());
       return proceed();
   }
}
