package com.cachingapp.tracing;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.loanapp.LoanAppHelper;


/**
 * @author
 */
public class SQLTracingAspect {
    
    private static Log sLog = LogFactory.getLog(SQLTracingAspect.class);
    
//    pointcut contextInitialized(ServletContextEvent event) : args(event) 
//    && (execution(void LoanAppContextListener.contextInitialized(ServletContextEvent)));
    
	pointcut traceGetInterestRates() :
		  call(* LoanAppHelper.getInterestRates(..)) && !within(SQLTracingAspect);
		
		before() : traceGetInterestRates() {
		  sLog.debug("Enter " + thisJoinPoint + ": " + new Date());
		}
		
		after() : traceGetInterestRates() {
		  sLog.debug("Exit " + thisJoinPoint + ": " + new Date());
		}

/*    
    pointcut logJdbcQueries() :  
    	execution(* java.sql.Connection+.prepare*(..));
    Object around() : logJdbcQueries()
    {
//        MethodRtti rtti = (MethodRtti)joinPoint.getRtti();
//        String query = (String)rtti.getParameterValues()[0];
//        System.out.println("===> query: " + query);
        
        System.out.println(thisJoinPoint.toShortString());
        
        return proceed();
    }
*/
		
/*    
    pointcut logValuesInPreparedStatement() : 
        (execution(void java.sql.PreparedStatement+.set*(..)));
    void around() : logValuesInPreparedStatement() {
//        MethodRtti rtti = (MethodRtti)joinPoint.getRtti();
//        Integer index = (Integer)rtti.getParameterValues()[0];
//        Object value = rtti.getParameterValues()[1];
//        System.out.println("     index=" + index.intValue() + " value=" + value.toString());
//        return joinPoint.proceed();
        
        System.out.println(thisJoinPoint.toShortString());
        
        proceed();
    }
*/
    
//    pointcut logTestCalls() :
//  	  call(* AssetDAOTest.testLoadAutomobileAssetByPrimaryKey(..)) && !within(SQLTracingAspect);
//  	
//  	before() : logTestCalls() {
//  	  sLog.debug("Calling " + thisJoinPoint.toShortString());
//  	}
//  	
//  	after() : logTestCalls() {
//  	  sLog.debug(thisJoinPoint.toShortString() + " called.");
//  	}
  	
}


