package com.loanapp.listener;

import javax.servlet.ServletContextListener;
import javax.servlet.ServletContextAttributeListener;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextAttributeEvent;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class LoanAppContextListener implements ServletContextListener,
        ServletContextAttributeListener {

   private static Log sLog = LogFactory.getLog(LoanAppContextListener.class);

	public LoanAppContextListener() {
   }

    //This method is invoked when the Web Application
    //is ready to service requests
    public void contextInitialized(ServletContextEvent event) {
        //Output a simple message to the server's console
        sLog.debug("LoanApp context is created.");
    }

    //This method is invoked when the Web Application
    //has been removed and is no longer able to accept
    //requests
    public void contextDestroyed(ServletContextEvent event) {
        //Output a simple message to the server's console
        sLog.debug("LoanApp context is removed.");
    }

    //This method is invoked when an attribute
    //is added to the ServletContext object
    public void attributeAdded(ServletContextAttributeEvent event) {
    	sLog.debug("An attribute was added to ServletContext object.");
    }

    //This method is invoked when an attribute
    //is removed from the ServletContext object
    public void attributeRemoved(ServletContextAttributeEvent event) {
    	sLog.debug("An attribute was removed from ServletContext object.");
    }

    //This method is invoked when an attribute
    //is replaced in the ServletContext object
    public void attributeReplaced(ServletContextAttributeEvent event) {
    	sLog.debug("An attribute was replaced in ServletContext object.");
    }

}
// End of LoanAppContextListener.java
