/*
 * Created on Jan 17, 2005
 *
 */
package com.cachingapp.tracing;

import java.util.Date;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.loanapp.LoanAppHelper;


/**
 * @author Administrator
 *
 */
public aspect Trace {
    
    private static Log sLog = LogFactory.getLog(Trace.class);
    
    long start, stop;
    long initFreeMemory, finalFreeMemory;

	pointcut traceGetInterestRates() :
	  call(* LoanAppHelper.getInterestRates(..)) && !within(Trace);
	
	before() : traceGetInterestRates() {
	  sLog.debug("Enter " + thisJoinPoint + ": " + new Date());
	  start = System.currentTimeMillis();
	  initFreeMemory = Runtime.getRuntime().freeMemory();
	  sLog.debug("Free Memory= " + thisJoinPoint + ": " + initFreeMemory + " bytes.");
	}
	
	after() : traceGetInterestRates() {
	  sLog.debug("Exit " + thisJoinPoint + ": " + new Date());
	  stop = System.currentTimeMillis();
	  sLog.debug("Time taken to run " + thisJoinPoint + "=" + (stop-start) + " ms.");
	  
	  finalFreeMemory = Runtime.getRuntime().freeMemory();
	  sLog.debug("Free Memory= " + thisJoinPoint + ": " + finalFreeMemory + " bytes.");
	  sLog.debug("Memory taken by cached objects : " + thisJoinPoint + " " + (initFreeMemory-finalFreeMemory) + " bytes.");
	  
	}
}
